import type { BindingMinifyOptions, BindingNormalizedOptions } from '../binding';
import type { SourcemapIgnoreListOption, SourcemapPathTransformOption } from '../types/misc';
import type { AddonFunction, AssetFileNamesFunction, ChunkFileNamesFunction, GlobalsFunction, OutputOptions } from './output-options';
import { RolldownPlugin } from '..';
export type InternalModuleFormat = 'es' | 'cjs' | 'iife' | 'umd' | 'app';
export interface NormalizedOutputOptions {
    name: string | undefined;
    file: string | undefined;
    dir: string | undefined;
    entryFileNames: string | ChunkFileNamesFunction;
    chunkFileNames: string | ChunkFileNamesFunction;
    assetFileNames: string | AssetFileNamesFunction;
    format: InternalModuleFormat;
    exports: NonNullable<OutputOptions['exports']>;
    sourcemap: boolean | 'inline' | 'hidden';
    cssEntryFileNames: string | ChunkFileNamesFunction;
    cssChunkFileNames: string | ChunkFileNamesFunction;
    inlineDynamicImports: boolean;
    externalLiveBindings: boolean;
    banner: AddonFunction;
    footer: AddonFunction;
    intro: AddonFunction;
    outro: AddonFunction;
    esModule: boolean | 'if-default-prop';
    extend: boolean;
    globals: Record<string, string> | GlobalsFunction;
    hashCharacters: 'base64' | 'base36' | 'hex';
    sourcemapDebugIds: boolean;
    sourcemapIgnoreList: SourcemapIgnoreListOption;
    sourcemapPathTransform: SourcemapPathTransformOption | undefined;
    minify: false | BindingMinifyOptions;
    comments: 'none' | 'preserve-legal';
    polyfillRequire: boolean;
    plugins: RolldownPlugin[];
}
export declare class NormalizedOutputOptionsImpl implements NormalizedOutputOptions {
    private inner;
    private outputOptions;
    private normalizedOutputPlugins;
    constructor(inner: BindingNormalizedOptions, outputOptions: OutputOptions, normalizedOutputPlugins: RolldownPlugin[]);
    get dir(): string | undefined;
    get entryFileNames(): string | ChunkFileNamesFunction;
    get chunkFileNames(): string | ChunkFileNamesFunction;
    get assetFileNames(): string | AssetFileNamesFunction;
    get format(): 'es' | 'cjs' | 'app' | 'iife' | 'umd';
    get exports(): 'default' | 'named' | 'none' | 'auto';
    get sourcemap(): boolean | 'inline' | 'hidden';
    get cssEntryFileNames(): string | ChunkFileNamesFunction;
    get cssChunkFileNames(): string | ChunkFileNamesFunction;
    get shimMissingExports(): boolean;
    get name(): string | undefined;
    get file(): string | undefined;
    get inlineDynamicImports(): boolean;
    get externalLiveBindings(): boolean;
    get banner(): AddonFunction;
    get footer(): AddonFunction;
    get intro(): AddonFunction;
    get outro(): AddonFunction;
    get esModule(): boolean | 'if-default-prop';
    get extend(): boolean;
    get globals(): Record<string, string> | GlobalsFunction;
    get hashCharacters(): 'base64' | 'base36' | 'hex';
    get sourcemapDebugIds(): boolean;
    get sourcemapIgnoreList(): SourcemapIgnoreListOption;
    get sourcemapPathTransform(): SourcemapPathTransformOption | undefined;
    get minify(): false | BindingMinifyOptions;
    get comments(): 'none' | 'preserve-legal';
    get polyfillRequire(): boolean;
    get plugins(): RolldownPlugin[];
}
